﻿using System;
using System.Net;
using System.Windows;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Notification;

namespace AkibanoJisacouponCs
{
    public partial class CouponPage : PhoneApplicationPage
    {
        private Microsoft.Phone.Notification.HttpNotificationChannel PushChannel;
        private WebClient WebClient = new WebClient();
        private const String ServiceUri = "http://localhost:8000/ChannelService.svc/SetChannelUri";
        private const string AppTitle = "AkibanoJisacoupon";

        public CouponPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(CouponPage_Loaded);
        }


        void CouponPage_Loaded(object sender, RoutedEventArgs e)
        {
            GetUri();
        }

        private void GetUri()
        {
            PushChannel = HttpNotificationChannel.Find(AppTitle);
            if (PushChannel == null)
            {
                PushChannel = new HttpNotificationChannel(AppTitle);
                PushChannel.ChannelUriUpdated += new EventHandler<NotificationChannelUriEventArgs>(PushChannel_ChannelUriUpdated);
                PushChannel.ErrorOccurred += new EventHandler<NotificationChannelErrorEventArgs>(PushChannel_ErrorOccurred);
                PushChannel.Open();
            }
            else
            {
                if (PushChannel.ConnectionStatus == ChannelConnectionStatus.Connected)
                {
                    SetUri(PushChannel.ChannelUri.ToString());
                }
            }
            if (!PushChannel.IsShellTileBound)
            {
                PushChannel.BindToShellTile();
            }
            if (!PushChannel.IsShellToastBound)
            {
                PushChannel.BindToShellToast();
            }
        }

        private void PushChannel_ChannelUriUpdated(object sender, NotificationChannelUriEventArgs e)
        {
            Dispatcher.BeginInvoke(() =>
            {
                SetUri(e.ChannelUri.ToString());
            });

        }

        private void PushChannel_ErrorOccurred(object sender, NotificationChannelErrorEventArgs e)
        {
            Dispatcher.BeginInvoke(() =>
            {
                MessageBox.Show(e.Message.ToString(), "Get Channel Uri", MessageBoxButton.OK);
            });
        }

        private void SetUri(String channelUri)
        {
            String uri = "userID=Claudia&uri=" + HttpUtility.UrlEncode(channelUri);
            WebClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(WebClient_DownloadStringCompleted);
            WebClient.DownloadStringAsync(new Uri(ServiceUri + "?" + uri));
        }

        private void WebClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            //ここでe.Resultの内容を判定
            MessageBox.Show("OK", "Set Channel Uri", MessageBoxButton.OK);
        }
    }
}