﻿using System;
using System.IO;
using System.Net;
using System.ServiceModel.Syndication;
using System.Windows;
using System.Xml;
using Microsoft.Phone.Controls;

namespace AkibanoJisacouponCs
{
    public partial class MainPage : PhoneApplicationPage
    {
        // コンストラクター
        public MainPage()
        {
            InitializeComponent();

            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        // ViewModel Items のデータを読み込みます
        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            WebClient cli = new WebClient();
            cli.DownloadStringCompleted +=new DownloadStringCompletedEventHandler(cli_DownloadStringCompleted);
            cli.DownloadStringAsync(new Uri("http://www.microsoft.com/japan/msdn/rss.xml", UriKind.Absolute));
        }
        
        void  cli_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                MessageBox.Show("エラー:" + e.Error.Message);
                return;
            }
            StringReader sr = new StringReader(e.Result);
            XmlReader xr = XmlReader.Create(sr);
            SyndicationFeed sf = SyndicationFeed.Load(xr);
            this.DataContext = sf;
        }
    }
}