﻿using System;
using System.Linq;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

namespace AkibanoWCFWebRole
{
    public class ChannelModels
    {
        public ResponseType SetRecords(string userID,string channelUri)
        {

            ResponseType returnCode = new ResponseType();

            try{
                Boolean isExists = false;
                TableServiceContext context;
                string connectionString = GetEnviroment.GetSettings("StorageConnection");
                var account = CloudStorageAccount.Parse(connectionString);
                var client = account.CreateCloudTableClient();
                UriEntity entity = new UriEntity();
                context = client.GetDataServiceContext();

                isExists = client.DoesTableExist("Channel");
                if (isExists)
                {
                    //テーブルがある場合
                    var query = from n in context.CreateQuery<UriEntity>("Channel")
                                where (n.Uri == channelUri)
                                select n;
                    if (query.ToArray().Count().ToString() == "0")
                    {
                        entity.Uri = channelUri;
                        context.AddObject("Channel", entity);
                        context.SaveChanges();
                    }
                }
                else
                {
                    //テーブルがない場合
                    client.CreateTableIfNotExist("Channel");
                    entity.Uri = channelUri;
                    context.AddObject("Channel", entity);
                    context.SaveChanges();
                }
                returnCode.IsOK = true;
                returnCode.Message = "OK";
            }
            catch (Exception ex)
            {
                returnCode.IsOK = false;
                returnCode.Message = ex.Message;
            }
            return returnCode;
        }

        internal Boolean SendToAllUser(ISendNotification send, string title, string content)
        {
            Boolean isOK = false;

            Boolean isExists = false;
            TableServiceContext context;
            string connectionString = GetEnviroment.GetSettings("StorageConnection");
            var account = CloudStorageAccount.Parse(connectionString);
            var client = account.CreateCloudTableClient();
            UriEntity entity = new UriEntity();
            context = client.GetDataServiceContext();

            isExists = client.DoesTableExist("Channel");
            if (isExists)
            {
                var query = from n in context.CreateQuery<UriEntity>("Channel")
                            select n;
                foreach (UriEntity item in query)
                {
                    try
                    {
                        if (send.SendNotification(item.Uri, title, content) != true)
                        {
                            //ここにエラー記録ロジックを書く
                        }
                    }
                    catch (Exception ex)
                    {
                        //ここにエラー記録ロジックを書く
                    }
                }
                isOK = true;
            }
            return isOK;            
        }
    }

    public class UriEntity : TableServiceEntity
    {
        public UriEntity()
        {
            this.PartitionKey = DateTime.UtcNow.ToString("yyyyMMdd");
            this.RowKey = Guid.NewGuid().ToString();
        }
        public string Uri { get; set; }
    }    
}
