﻿using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace AkibanoWCFWebRole
{
    // メモ: [リファクター] メニューの [名前の変更] コマンドを使用すると、コードと config ファイルの両方で同時にインターフェイス名 "IService1" を変更できます。
    [ServiceContract]
    public interface IChannelService
    {

        [OperationContract]
        [WebGet(ResponseFormat=WebMessageFormat.Json)]
        ResponseType SetChannelUri(string userID, string uri);
    }

    // サービス操作に複合型を追加するには、以下のサンプルに示すようにデータ コントラクトを使用します。
    [DataContract]
    public class ResponseType
    {
        bool _isOK = true;
        string _message = "Hello ";

        [DataMember]
        public bool IsOK
        {
            get { return _isOK; }
            set { _isOK = value; }
        }

        [DataMember]
        public string Message
        {
            get { return _message; }
            set { _message = value; }
        }
    }
}
