﻿using System;
using System.Net;

namespace AkibanoWCFWebRole
{
    public class SendToast : ISendNotification
    {
        public Boolean SendNotification(string channelUri, string title, string content)
        {
            Boolean isOK = false;
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(channelUri);
            string xmlData = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                "<wp:Notification xmlns:wp=\"WPNotification\">" +
                "<wp:Toast>" +
                "<wp:Text1>" + title + "</wp:Text1>" +
                "<wp:Text2>" + content + "</wp:Text2>" +
                "<wp:Param>/CouponPage.xaml</wp:Param>" +
                "</wp:Toast>" +
                "</wp:Notification>";
            byte[] notificationMessage = System.Text.Encoding.UTF8.GetBytes(xmlData);

            req.Method = "POST";
            req.ContentLength = notificationMessage.Length;
            req.ContentType = "text/xml";
            req.Headers.Add("X-WindowsPhone-Target", "toast");
            req.Headers.Add("X-NotificationClass", "2");
            using (System.IO.Stream reqStream = req.GetRequestStream()) 
            {
                reqStream.Write(notificationMessage, 0 ,notificationMessage.Length);
                reqStream.Close();
            }
            return isOK;
        }
    }

    public class SendTile : ISendNotification
    {
        public Boolean SendNotification(string channelUri, string title, string content)
        {
            Boolean isOK = false;
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(channelUri);
            string xmlData = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                "<wp:Notification xmlns:wp=\"WPNotification\">" +
                "<wp:Tile>" +
                "<wp:Count>" + DateTime.Now.Day + "</wp:Count>" +
                "<wp:BackTitle>" + title + "</wp:BackTitle>" +
                "<wp:BackContent>" + content + "</wp:BackContent>" +
                "</wp:Tile>" +
                "</wp:Notification>";
            byte[] notificationMessage = System.Text.Encoding.UTF8.GetBytes(xmlData);

            req.Method = "POST";
            req.ContentLength = notificationMessage.Length;
            req.ContentType = "text/xml";
            req.Headers.Add("X-WindowsPhone-Target", "token");
            req.Headers.Add("X-NotificationClass", "1");
            using (System.IO.Stream reqStream = req.GetRequestStream())
            {
                reqStream.Write(notificationMessage, 0, notificationMessage.Length);
                reqStream.Close();
            }
            return isOK;
        }
    }
}
