﻿Partial Public Class CouponPage
    Inherits PhoneApplicationPage

    Private WithEvents PushChannel As Microsoft.Phone.Notification.HttpNotificationChannel
    Private WithEvents WebClient As New WebClient
    Private Const ServiceUri As String = "http://localhost:8000/ChannelService.svc/SetChannelUri"
    Private AppTitle As String = MyApplication.ApplicationTitle

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' クーポンを表示しPush通知に登録する
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CouponPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Call GetUri()
    End Sub

    Private Sub GetUri()
        PushChannel = Microsoft.Phone.Notification.HttpNotificationChannel.Find(AppTitle)
        If PushChannel Is Nothing Then
            'チャンネル初期利用
            PushChannel = New Microsoft.Phone.Notification.HttpNotificationChannel(AppTitle)
            PushChannel.Open()
        Else
            If PushChannel.ConnectionStatus = Microsoft.Phone.Notification.ChannelConnectionStatus.Connected Then
                'チャンネル登録済
                Call SetUri(PushChannel.ChannelUri.ToString)
            End If
        End If
        If Not PushChannel.IsShellTileBound Then
            PushChannel.BindToShellTile()
        End If
        If Not PushChannel.IsShellToastBound Then
            PushChannel.BindToShellToast()
        End If
    End Sub

    Private Sub PushChannel_ChannelUriUpdated(sender As Object,
                                          e As Microsoft.Phone.Notification.NotificationChannelUriEventArgs) _
                                      Handles PushChannel.ChannelUriUpdated
        Dispatcher.BeginInvoke(Sub()
                                   Call SetUri(e.ChannelUri.ToString)
                               End Sub)
    End Sub

    Private Sub PushChannel_ErrorOccurred(sender As Object,
                                          e As Microsoft.Phone.Notification.NotificationChannelErrorEventArgs) _
                                      Handles PushChannel.ErrorOccurred
        Dispatcher.BeginInvoke(Sub()
                                   MessageBox.Show(e.Message, "Get Channel Uri", MessageBoxButton.OK)
                               End Sub)
    End Sub

    Private Sub SetUri(ByVal channelUri As String)
        Dim uri As String = "userID=Claudia&uri=" & HttpUtility.UrlEncode(channelUri)
        WebClient.DownloadStringAsync(New Uri(ServiceUri & "?" & uri))
    End Sub

    Private Sub WebClient_DownloadStringCompleted(sender As Object,
                                                  e As System.Net.DownloadStringCompletedEventArgs) Handles WebClient.DownloadStringCompleted
        Using stream As New System.IO.MemoryStream(System.Text.Encoding.UTF8.GetBytes(e.Result))
            Dim serializer As New System.Runtime.Serialization.Json.DataContractJsonSerializer(GetType(TChannelUri))
            Dim result As TChannelUri = serializer.ReadObject(stream)
            If result.IsOK Then
                MessageBox.Show("OK", "Set Channel Uri", MessageBoxButton.OK)
            Else
                MessageBox.Show(result.Message, "Set Channel Uri", MessageBoxButton.OK)
            End If
        End Using
    End Sub

    <System.Runtime.Serialization.DataContract()> _
    Public Class TChannelUri
        <System.Runtime.Serialization.DataMember()> _
        Public Property IsOK As Boolean
        <System.Runtime.Serialization.DataMember()> _
        Public Property Message As String
    End Class

End Class