﻿Imports System.Linq
Imports Microsoft.WindowsAzure.StorageClient
Imports Microsoft.WindowsAzure

Public Class ChannelModels
    Public Function SetRecords(ByVal userID As String,
                               ByVal channelUri As String) As ResponseType
        Dim returnCode As New ResponseType

        Try
            Dim isExists As Boolean = False
            Dim context As TableServiceContext
            Dim connectionString As String = GetEnviroment.GetSettings("StorageConnection")
            Dim account = CloudStorageAccount.Parse(connectionString)
            Dim client = account.CreateCloudTableClient
            Dim entity As New UriEntity

            context = client.GetDataServiceContext
            isExists = client.DoesTableExist("Channel")
            If isExists Then
                'テーブルがある場合
                Dim query = From n In context.CreateQuery(Of UriEntity)("Channel")
                            Where (n.Uri = channelUri)
                            Select n
                If (query.ToArray().Count().ToString() = "0") Then
                    entity.Uri = channelUri
                    context.AddObject("Channel", entity)
                    context.SaveChanges()
                End If
            Else
                'テーブルがない場合
                client.CreateTableIfNotExist("Channel")
                entity.Uri = channelUri
                context.AddObject("Channel", entity)
                context.SaveChanges()
            End If
            returnCode.IsOK = True
            returnCode.Message = "OK"
        Catch ex As Exception
            returnCode.IsOK = False
            returnCode.Message = ex.Message
        End Try
        Return returnCode
    End Function

    Friend Function SendToAllUser(ByVal send As ISendNotificatoin,
                                  ByVal title As String,
                                  ByVal content As String) As Boolean
        Dim isOK As Boolean = False
        Dim isExists As Boolean = False
        Dim context As TableServiceContext
        Dim connectionString As String = GetEnviroment.GetSettings("StorageConnection")
        Dim account = CloudStorageAccount.Parse(connectionString)
        Dim client = account.CreateCloudTableClient()
        Dim entity As UriEntity = New UriEntity()

        context = client.GetDataServiceContext()
        isExists = client.DoesTableExist("Channel")
        If (isExists) Then
            Dim query = From n In context.CreateQuery(Of UriEntity)("Channel")
                        Select n
            For Each item As UriEntity In query
                Try
                    If (send.SendNotification(item.Uri, title, content) <> True) Then
                        'ここにエラー記録ロジックを書く
                    End If

                Catch ex As Exception
                    'ここにエラー記録ロジックを書く
                End Try
            Next
            isOK = True
        End If
        Return isOK
    End Function

    Public Class UriEntity
        Inherits TableServiceEntity

        Public Sub New()
            MyBase.New()
            Me.PartitionKey = DateTime.UtcNow.ToString("yyyyMMdd")
            Me.RowKey = Guid.NewGuid().ToString()
        End Sub
        Public Property Uri As String
    End Class
End Class
